/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIExtensionManager.idl
 */

#ifndef __gen_nsIExtensionManager_h__
#define __gen_nsIExtensionManager_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIInputStream; /* forward declaration */

class nsIRDFDataSource; /* forward declaration */

class nsIDOMWindowInternal; /* forward declaration */


/* starting interface:    nsIExtensionManager */
#define NS_IEXTENSIONMANAGER_IID_STR "c3515b0f-99f4-453b-805e-1fdf5724d6d9"

#define NS_IEXTENSIONMANAGER_IID \
  {0xc3515b0f, 0x99f4, 0x453b, \
    { 0x80, 0x5e, 0x1f, 0xdf, 0x57, 0x24, 0xd6, 0xd9 }}

class NS_NO_VTABLE nsIExtensionManager : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IEXTENSIONMANAGER_IID)

  /* void installExtensionFromStream (in nsIInputStream aStream, in boolean aUseProfile); */
  NS_IMETHOD InstallExtensionFromStream(nsIInputStream *aStream, PRBool aUseProfile) = 0;

  /* void uninstallExtension (in string aExtensionID); */
  NS_IMETHOD UninstallExtension(const char *aExtensionID) = 0;

  /* void enableExtension (in string aExtensionID); */
  NS_IMETHOD EnableExtension(const char *aExtensionID) = 0;

  /* void disableExtension (in string aExtensionID); */
  NS_IMETHOD DisableExtension(const char *aExtensionID) = 0;

  /* void updateExtension (in string aExtensionID, in nsIDOMWindowInternal aDOMWindow); */
  NS_IMETHOD UpdateExtension(const char *aExtensionID, nsIDOMWindowInternal *aDOMWindow) = 0;

  /* void installTheme (in string aThemeID); */
  NS_IMETHOD InstallTheme(const char *aThemeID) = 0;

  /* void uninstallTheme (in string aThemeID); */
  NS_IMETHOD UninstallTheme(const char *aThemeID) = 0;

  /* void updateTheme (in string aThemeID); */
  NS_IMETHOD UpdateTheme(const char *aThemeID) = 0;

  /* readonly attribute nsIRDFDataSource datasource; */
  NS_IMETHOD GetDatasource(nsIRDFDataSource * *aDatasource) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIEXTENSIONMANAGER \
  NS_IMETHOD InstallExtensionFromStream(nsIInputStream *aStream, PRBool aUseProfile); \
  NS_IMETHOD UninstallExtension(const char *aExtensionID); \
  NS_IMETHOD EnableExtension(const char *aExtensionID); \
  NS_IMETHOD DisableExtension(const char *aExtensionID); \
  NS_IMETHOD UpdateExtension(const char *aExtensionID, nsIDOMWindowInternal *aDOMWindow); \
  NS_IMETHOD InstallTheme(const char *aThemeID); \
  NS_IMETHOD UninstallTheme(const char *aThemeID); \
  NS_IMETHOD UpdateTheme(const char *aThemeID); \
  NS_IMETHOD GetDatasource(nsIRDFDataSource * *aDatasource); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIEXTENSIONMANAGER(_to) \
  NS_IMETHOD InstallExtensionFromStream(nsIInputStream *aStream, PRBool aUseProfile) { return _to InstallExtensionFromStream(aStream, aUseProfile); } \
  NS_IMETHOD UninstallExtension(const char *aExtensionID) { return _to UninstallExtension(aExtensionID); } \
  NS_IMETHOD EnableExtension(const char *aExtensionID) { return _to EnableExtension(aExtensionID); } \
  NS_IMETHOD DisableExtension(const char *aExtensionID) { return _to DisableExtension(aExtensionID); } \
  NS_IMETHOD UpdateExtension(const char *aExtensionID, nsIDOMWindowInternal *aDOMWindow) { return _to UpdateExtension(aExtensionID, aDOMWindow); } \
  NS_IMETHOD InstallTheme(const char *aThemeID) { return _to InstallTheme(aThemeID); } \
  NS_IMETHOD UninstallTheme(const char *aThemeID) { return _to UninstallTheme(aThemeID); } \
  NS_IMETHOD UpdateTheme(const char *aThemeID) { return _to UpdateTheme(aThemeID); } \
  NS_IMETHOD GetDatasource(nsIRDFDataSource * *aDatasource) { return _to GetDatasource(aDatasource); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIEXTENSIONMANAGER(_to) \
  NS_IMETHOD InstallExtensionFromStream(nsIInputStream *aStream, PRBool aUseProfile) { return !_to ? NS_ERROR_NULL_POINTER : _to->InstallExtensionFromStream(aStream, aUseProfile); } \
  NS_IMETHOD UninstallExtension(const char *aExtensionID) { return !_to ? NS_ERROR_NULL_POINTER : _to->UninstallExtension(aExtensionID); } \
  NS_IMETHOD EnableExtension(const char *aExtensionID) { return !_to ? NS_ERROR_NULL_POINTER : _to->EnableExtension(aExtensionID); } \
  NS_IMETHOD DisableExtension(const char *aExtensionID) { return !_to ? NS_ERROR_NULL_POINTER : _to->DisableExtension(aExtensionID); } \
  NS_IMETHOD UpdateExtension(const char *aExtensionID, nsIDOMWindowInternal *aDOMWindow) { return !_to ? NS_ERROR_NULL_POINTER : _to->UpdateExtension(aExtensionID, aDOMWindow); } \
  NS_IMETHOD InstallTheme(const char *aThemeID) { return !_to ? NS_ERROR_NULL_POINTER : _to->InstallTheme(aThemeID); } \
  NS_IMETHOD UninstallTheme(const char *aThemeID) { return !_to ? NS_ERROR_NULL_POINTER : _to->UninstallTheme(aThemeID); } \
  NS_IMETHOD UpdateTheme(const char *aThemeID) { return !_to ? NS_ERROR_NULL_POINTER : _to->UpdateTheme(aThemeID); } \
  NS_IMETHOD GetDatasource(nsIRDFDataSource * *aDatasource) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDatasource(aDatasource); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsExtensionManager : public nsIExtensionManager
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIEXTENSIONMANAGER

  nsExtensionManager();

private:
  ~nsExtensionManager();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsExtensionManager, nsIExtensionManager)

nsExtensionManager::nsExtensionManager()
{
  /* member initializers and constructor code */
}

nsExtensionManager::~nsExtensionManager()
{
  /* destructor code */
}

/* void installExtensionFromStream (in nsIInputStream aStream, in boolean aUseProfile); */
NS_IMETHODIMP nsExtensionManager::InstallExtensionFromStream(nsIInputStream *aStream, PRBool aUseProfile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void uninstallExtension (in string aExtensionID); */
NS_IMETHODIMP nsExtensionManager::UninstallExtension(const char *aExtensionID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void enableExtension (in string aExtensionID); */
NS_IMETHODIMP nsExtensionManager::EnableExtension(const char *aExtensionID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void disableExtension (in string aExtensionID); */
NS_IMETHODIMP nsExtensionManager::DisableExtension(const char *aExtensionID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void updateExtension (in string aExtensionID, in nsIDOMWindowInternal aDOMWindow); */
NS_IMETHODIMP nsExtensionManager::UpdateExtension(const char *aExtensionID, nsIDOMWindowInternal *aDOMWindow)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void installTheme (in string aThemeID); */
NS_IMETHODIMP nsExtensionManager::InstallTheme(const char *aThemeID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void uninstallTheme (in string aThemeID); */
NS_IMETHODIMP nsExtensionManager::UninstallTheme(const char *aThemeID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void updateTheme (in string aThemeID); */
NS_IMETHODIMP nsExtensionManager::UpdateTheme(const char *aThemeID)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIRDFDataSource datasource; */
NS_IMETHODIMP nsExtensionManager::GetDatasource(nsIRDFDataSource * *aDatasource)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIExtensionManager_h__ */
